using System;
using System.Drawing.Design;
using System.ComponentModel;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace ImTryin.ClassesLanguage
{
    public abstract class AbstractModifierEditor : UITypeEditor
    {
        private IWindowsFormsEditorService wfes = null;

        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.DropDown;
        }

        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            string[] modifiers = GetStringCollection();
            
            ListBox listBox = new ListBox();
            listBox.Font = new System.Drawing.Font("Courier New", 10);
            listBox.Height = modifiers.Length * listBox.Font.Height;
            listBox.BorderStyle = BorderStyle.None;
            listBox.Items.AddRange(modifiers);
            listBox.Click += new EventHandler(listBox_Click);

            listBox.SelectedItem = value;

            wfes = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
            wfes.DropDownControl(listBox);

            return listBox.SelectedItem;
        }

        protected abstract string[] GetStringCollection();

        private void listBox_Click(object sender, EventArgs args)
        {
            wfes.CloseDropDown();
        }
    }
}
