using System;
using System.Drawing.Design;
using System.ComponentModel;
using System.Windows.Forms.Design;

namespace ImTryin.ClassesLanguage
{
    public class CodeEditor : UITypeEditor
    {
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }

        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            Method curMethod = (Method) context.Instance;
            Class curClass = curMethod.Class;
            string description = ((curClass != null) ? curClass.Name + "." : "") + curMethod.Name;

            CodingForm cform = new CodingForm(value as string);
            cform.Text += (description.Length > 0) ? " : " + description : "";
            IWindowsFormsEditorService wfes = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
            wfes.ShowDialog(cform);
            return cform.Code;
        }
    }
}
