using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ImTryin.ClassesLanguage
{
    public partial class CodingForm : Form
    {
        private string backupCode = string.Empty;

        private CodingForm()
        {
            InitializeComponent();
        }

        public CodingForm(string initialCode) : this()
        {
            codeRichTextBox.Text = initialCode;
        }

        public string Code
        {
            get
            {
                return codeRichTextBox.Text;
            }
            set
            {
                codeRichTextBox.Text = value;
            }
        }

        private void CodingForm_Load(object sender, EventArgs e)
        {
            backupCode = Code;
        }

        private void CodingForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (DialogResult == DialogResult.Cancel)
                UndoChanges();
        }

        private void okToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
            Close();
        }

        private void cancelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }

        private void UndoChanges()
        {
            Code = backupCode;
        }
    }
}