using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using Microsoft.VisualStudio.TextTemplating.VSHost;

namespace ImTryin.ClassesLanguage
{
    [Guid("16C6090D-6A3E-494d-9593-0DF5C49C9852")]
    [ProvideCodeGenerator(typeof(DirectCodeGenerator), "ClassesCodeGenerator", "Custom tool that generates files based on Classes DSL", true)]
    public class DirectCodeGenerator : TemplatedCodeGenerator
    {
        protected override byte[] GenerateCode(string inputFileName, string inputFileContent)
        {
            inputFileContent = GetTemplateFromResource("ImTryin.ClassesLanguage.Resources.Classes.tt");
            inputFileContent = inputFileContent.Replace("%FILENAMEMARKER%", inputFileName);
            return base.GenerateCode(inputFileName, inputFileContent);
        }

        private string GetTemplateFromResource(string resourceName)
        {
            Assembly executingAssembly = Assembly.GetExecutingAssembly();
            using(Stream resourceStream = executingAssembly.GetManifestResourceStream(resourceName))
            using(StreamReader reader = new StreamReader(resourceStream))
                return reader.ReadToEnd();
        }
    }
}