using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using Microsoft.VisualStudio.TextTemplating.VSHost;

namespace ImTryin.ObjectsLanguage
{
    [Guid("17A2D4C8-CAE2-422f-AC3E-4DA4CAB4A2D7")]
    [ProvideCodeGenerator(typeof(DirectCodeGenerator), "ObjectsCodeGenerator", "Custom tool that generates files based on Objects DSL", true)]
    public class DirectCodeGenerator : TemplatedCodeGenerator
    {
        protected override byte[] GenerateCode(string inputFileName, string inputFileContent)
        {
            inputFileContent = GetTemplateFromResource("ImTryin.ObjectsLanguage.Resources.Objects.tt");
            inputFileContent = inputFileContent.Replace("%FILENAMEMARKER%", inputFileName);
            return base.GenerateCode(inputFileName, inputFileContent);
        }

        private string GetTemplateFromResource(string resourceName)
        {
            Assembly executingAssembly = Assembly.GetExecutingAssembly();
            using(Stream resourceStream = executingAssembly.GetManifestResourceStream(resourceName))
            using(StreamReader reader = new StreamReader(resourceStream))
                return reader.ReadToEnd();
        }
    }
}