using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using Microsoft.VisualStudio.TextTemplating.VSHost;

namespace ImTryin.StateMachineLanguage
{
    [Guid("276CCFDB-B389-4972-AAE1-1D06B11AA575")]
    [ProvideCodeGenerator(typeof(DirectCodeGenerator), "StateMachineCodeGenerator", "Custom tool that generates files based on State Machine DSL", true)]
    public class DirectCodeGenerator : TemplatedCodeGenerator
    {
        protected override byte[] GenerateCode(string inputFileName, string inputFileContent)
        {
            inputFileContent = GetTemplateFromResource("ImTryin.StateMachineLanguage.Resources.StateMachine.tt");
            inputFileContent = inputFileContent.Replace("%FILENAMEMARKER%", inputFileName);
            return base.GenerateCode(inputFileName, inputFileContent);
        }

        private string GetTemplateFromResource(string resourceName)
        {
            Assembly executingAssembly = Assembly.GetExecutingAssembly();
            using(Stream resourceStream = executingAssembly.GetManifestResourceStream(resourceName))
            using(StreamReader reader = new StreamReader(resourceStream))
                return reader.ReadToEnd();
        }
    }
}